#!/bin/bash

if [ "$FROM_YAML" = "yes" ]; then
	COVERALLS="--coveralls-id=$TRAVIS_JOB_ID"
else
	unset COVERALLS
fi

CURDIR="$(pwd)"

rm -rf kcov-user* kcov-lock-queue*
mkdir -p /tmp/kcov-root
./tests/scripts/prepare_test_environment
./tests/scripts/run_all_tests || exit 3
KUSR="$USER"
KGRP="$(id -gn "$KUSR")"
rm -rf kcov-all
mkdir -p kcov-all
rm -rf kcov-sendmail
rm -rf kcov-root
cp -r /tmp/kcov-root ${CURDIR}/
sudo cp -r /tmp/kcov-sendmail ${CURDIR}/
sudo chown -R "$KUSR":"$KGRP" ${CURDIR}/kcov-sendmail
sudo chown -R "$KUSR":"$KGRP" ${CURDIR}/kcov-root
kcov --merge $COVERALLS ${CURDIR}/kcov-all ${CURDIR}/kcov-user* ${CURDIR}/kcov-sendmail ${CURDIR}/kcov-root ${CURDIR}/kcov-lock-queue*
