# msmtp as smtpd requires one uid/gid.  Let me know if the uid/gid collides
# with another package.
%define msmtp_scripts_uid	183
%define msmtp_scripts_user	msmtp
%define msmtp_scripts_gid	183
%define msmtp_scripts_group	msmtp

%define msmtp_scripts_config_dir	%{_sysconfdir}
%define msmtp_scripts_command_dir	%{_bindir}
%define msmtp_scripts_admcmd_dir	%{_sbindir}
%define msmtp_scripts_queue_dir		%{_var}/spool/msmtp
%define msmtp_scripts_lock_dir		%{_var}/lock/msmtp
%define msmtp_scripts_doc_dir		%{_docdir}/%{name}-%{version}
%define debug_package			%{nil}


Name: msmtp-scripts
Summary: Wrappers around MSMTP to add additional functionality
Version: 1.2.5.1
Release: 2%{?dist}
URL: https://msmtp-scripts.thecshore.com
License: GPLv3+

Source0: https://launchpad.net/%{name}/trunk/%{version}/+download/%{name}-%{version}.tar.gz

BuildRoot: %{_tmppath}/${name}-%{version}-%{release}-root-%(%{__id_u} -n)

# Determine the different packages required for building msmtpq-ng
BuildRequires: systemd-units
BuildRequires: perl-podlators

%if 0%{?fedora} >= 30
BuildRequires: policycoreutils-python-utils
%else
BuildRequires: policycoreutils-python
%endif

%description
msmtp-scripts are wrappers around MSMTP SMTP Client that allow
it to act as a queuing Mail Transport Agent (MTA)
(see msmtpq-ng-mta package for use as system MTA)

%package msmtpq-ng

Summary: Wrapper around MSMTP to add additional functionality
Requires: msmtp
BuildArch: noarch

%description msmtpq-ng
msmtpq-ng are wrappers around MSMTP SMTP Client that allow
it to act as a queuing Mail Transport Agent (MTA)
(see msmtpq-ng-mta package for use as system MTA)


%package msmtpq-ng-mta
Summary: msmtpq-ng as Mail Transport Agent (MTA)
BuildArch: noarch
Requires: %{name}-msmtpq-ng = %{version}-%{release}
Requires(post): %{_sbindir}/alternatives
Requires(preun): %{_sbindir}/alternatives
Conflicts: postfix
Provides: MTA
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd


%description msmtpq-ng-mta
This package provides the wrapper for system Mail Transport
Agent (MTA) functionality.  That is for being the mailer for
system-generated email (via acting as 'sendmail')

%package ms-mta-smtpd-systemd
Summary: msmtpq-ng-mta as SMTPD daemon using systemd sockets
BuildArch: noarch
Requires: %{name}-msmtpq-ng = %{version}-%{release}
Requires: %{name}-msmtpq-ng-mta = %{version}-%{release}
Requires(pre): %{_sbindir}/groupadd
Requires(pre): %{_sbindir}/useradd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
Provides: smtpd smtpdaemon server(smtp)

%description ms-mta-smtpd-systemd
This package allows msmtpq-ng-mta to act as a basic
non-authenticating SMTPD daemon using systemd sockets.

%package ms-mta-smtpd-xinetd
Summary: msmtpq-ng-mta as SMTPD daemon using xinetd
BuildArch: noarch
Requires: %{name}-msmtpq-ng = %{version}-%{release}
Requires: %{name}-msmtpq-ng-mta = %{version}-%{release}
Requires: xinetd
Requires(pre): %{_sbindir}/groupadd
Requires(pre): %{_sbindir}/useradd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
Requires(postun): xinetd
Provides: smtpd smtpdaemon server(smtp)

%description ms-mta-smtpd-xinetd
This package allows msmtpq-ng-mta to act as a basic
non-authentication SMTPD daemos using the xineted
wrapper.

%package logwatch-selinux
Summary: Allows logwatch to use msmtpq-ng-mta with SELinux enabled
BuildArch: noarch
Requires: %{name}-msmtpq-ng-mta = %{version}-%{release}
Requires: logwatch
Requires(post): policycoreutils
Requires(preun): policycoreutils
Requires(postun): policycoreutils

%description logwatch-selinux
This package allows logwatch to use msmqpq-ng-mta from it's usual
systemd timer when SELinux is enforcing.

%prep
%setup -q -n msmtp-scripts-%{version}

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

# Copy the binaries
mkdir -p %{buildroot}%{msmtp_scripts_command_dir}
install -m 755 src/usr/bin/msmtpq-ng %{buildroot}%{msmtp_scripts_command_dir}/msmtpq-ng
install -m 755 src/usr/bin/msmtpq-ng-queue %{buildroot}%{msmtp_scripts_command_dir}/msmtpq-ng-queue

mkdir -p %{buildroot}%{_mandir}/man1
# Copy the manpages
install -m 644 src/usr/share/man/man1/msmtpq-ng.1 %{buildroot}%{_mandir}/man1/msmtpq-ng.1
install -m 644 src/usr/share/man/man1/msmtpq-ng-queue.1 %{buildroot}%{_mandir}/man1/msmtpq-ng-queue.1

# prepare documentation
mkdir -p %{buildroot}%{msmtp_scripts_doc_dir}
cp -p AUTHORS COPYING NEWS README.md THANKS doc/README.msmtpq-ng %{buildroot}%{msmtp_scripts_doc_dir}

find %{buildroot}%{msmtp_scripts_doc_dir} -type f | xargs chmod 644

# config file
mkdir -p %{buildroot}%{_sysconfdir}
install -m 644 src/etc/msmtpq-ng.rc %{buildroot}%{_sysconfdir}/msmtpq-ng.rc

## msmtpq-ng-mta

# Copy the binaries
mkdir -p %{buildroot}%{msmtp_scripts_admcmd_dir}
install -m 755 src/usr/sbin/msmtpq-ng-mta %{buildroot}%{msmtp_scripts_admcmd_dir}/msmtpq-ng-mta
install -m 755 src/usr/sbin/msmtpq-ng-queue-mta %{buildroot}%{msmtp_scripts_admcmd_dir}/msmtpq-ng-queue-mta

# Generate aliases man page (and don't conflict with sendmail or postfix)
mkdir -p %{buildroot}%{_mandir}/man1
pod2man --center "" --date "" --release "" --section=1 debian/newaliases.pod > %{buildroot}%{_mandir}/man1/newaliases.msmtpq-ng-mta.1

# Prepare alternate names for binaries (symlinks)
pushd %{buildroot}%{_sbindir}
ln -sf msmtpq-ng-mta sendmail.msmtpq-ng-mta
# And non-alternative binaries
## TODO: If can convince upstream to add mta-post* alternatives
## symlinks we should make these alternatives symlinks
ln -sf msmtpq-ng-queue-mta postsuper
ln -sf msmtpq-ng-queue-mta postqueue
popd
pushd %{buildroot}%{_bindir}
ln -sf ../sbin/msmtpq-ng-queue-mta mailq.msmtpq-ng-mta
ln -sf ../../bin/true newaliases.msmtpq-ng-mta
popd
mkdir -p %{buildroot}/usr/lib
pushd %{buildroot}/usr/lib
ln -sf ../sbin/msmtpq-ng-mta sendmail.msmtpq-ng-mta
popd

pushd %{buildroot}%{_mandir}/man1
# Prepare alternate names for manpages (symlinks)
ln -sf msmtpq-ng-queue.1 mailq.msmtpq-ng-mta.1
ln -sf msmtpq-ng-queue.1 msmtpq-ng-queue-mta.1
# And non-alternative manpages
ln -sf msmtpq-ng.1 msmtpq-ng-mta.1
## TODO: If can convince upstream to add mta-post* alternatives
## symlinks we should make these alternatives symlinks
ln -sf msmtpq-ng-queue.1 postsuper.1
ln -sf msmtpq-ng-queue.1 postqueue.1
popd
mkdir -p %{buildroot}%{_mandir}/man5
pushd %{buildroot}%{_mandir}/man5
ln -sf ../man1/msmtp.1 aliases.msmtpq-ng-mta.5
popd
mkdir -p %{buildroot}%{_mandir}/man8
pushd $RPM_BUILD_ROOT%{_mandir}/man8
ln -sf ../man1/msmtpq-ng.1 sendmail.msmtpq-ng-mta.8
popd

# Queue and lock dir need to allow any user, with per-user
# subdirs (msmtpq-ng umask should make the private to the user).
mkdir -p -m 1777 %{buildroot}%{msmtp_scripts_queue_dir}
mkdir -p -m 1777 %{buildroot}%{msmtp_scripts_lock_dir}
# volatile lock dir
mkdir -p %{buildroot}%{_tmpfilesdir}
install -m 644 src/etc/tmpfiles.d/msmtpq-ng-mta.conf %{buildroot}%{_tmpfilesdir}/msmtpq-ng-mta.conf
install -d -m 1777 %{buildroot}/var/lock/msmtp/

# systemd timer
mkdir -p %{buildroot}%{_unitdir}
install -m 644 src/etc/systemd/system/ms-mta-queue-run.service %{buildroot}%{_unitdir}/ms-mta-queue-run.service
install -m 644 src/etc/systemd/system/ms-mta-queue-run.timer %{buildroot}%{_unitdir}/ms-mta-queue-run.timer

# docs
mkdir -p %{buildroot}%{msmtp_scripts_doc_dir}
cp -p doc/README.msmtpq-ng-mta %{buildroot}%{msmtp_scripts_doc_dir}

find $RPM_BUILD_ROOT%{msmtp_scripts_doc_dir} -type f | xargs chmod 644

# config file
mkdir -p %{buildroot}%{_sysconfdir}
install -m 644 src/etc/msmtpq-ng-mta.rc %{buildroot}%{_sysconfdir}/msmtpq-ng-mta.rc

## ms-mta-smtpd-systemd

# Systemd
mkdir -p %{buildroot}%{_unitdir}
install -m 644 src/etc/systemd/system/ms-mta-smtpd@.service %{buildroot}%{_unitdir}/ms-mta-smtpd@.service
install -m 644 src/etc/systemd/system/ms-mta-smtpd.socket %{buildroot}%{_unitdir}/ms-mta-smtpd.socket

## ms-mta-smtpd-xinetd

# xinetd
mkdir -p %{buildroot}%{_sysconfdir}/xinetd.d
install -m 644 src/etc/xinetd.d/ms-mta-smtpd %{buildroot}%{_sysconfdir}/xinetd.d/ms-mta-smtpd

# logwatch selinux
checkmodule -m -o %{buildroot}/msmtp_scripts_logwatch.mod msmtp_scripts_logwatch.te
semodule_package -m %{buildroot}/msmtp_scripts_logwatch.mod -o %{buildroot}/msmtp_scripts_logwatch.pp
install -p -m 644 -D %{buildroot}/msmtp_scripts_logwatch.pp %{buildroot}%{_datadir}/selinux/packages/%{name}/msmtp_scripts_logwatch.pp
rm -f %{buildroot}/msmtp_scripts_logwatch.mod
rm -f %{buildroot}/msmtp_scripts_logwatch.pp

## mmsmtpq-ng-mta

# prepare alternatives ghosts 
for i in %{msmtp_scripts_admcmd_dir}/sendmail %{_bindir}/mailq \
	%{_bindir}/newaliases /usr/lib/sendmail \
	%{_mandir}/{man1/{mailq.1,newaliases.1},man5/aliases.5,man8/sendmail.8}
do
	touch $RPM_BUILD_ROOT$i
done

%post msmtpq-ng-mta

# In Fedora msmtp is setup as a priority 40 MTA in it's own right, so we must
# set msmtpq-ng-mta to a higher priority in order to actually be used.
%{_sbindir}/alternatives --install %{msmtp_scripts_admcmd_dir}/sendmail mta %{msmtp_scripts_admcmd_dir}/sendmail.msmtpq-ng-mta 50 \
	--slave %{_bindir}/mailq mta-mailq %{_bindir}/mailq.msmtpq-ng-mta \
	--slave %{_bindir}/newaliases mta-newaliases %{_bindir}/newaliases.msmtpq-ng-mta \
	--slave /usr/lib/sendmail mta-sendmail /usr/lib/sendmail.msmtpq-ng-mta \
	--slave %{_mandir}/man1/mailq.1.gz mta-mailqman %{_mandir}/man1/mailq.msmtpq-ng-mta.1.gz \
	--slave %{_mandir}/man1/newaliases.1.gz mta-newaliasesman %{_mandir}/man1/newaliases.msmtpq-ng-mta.1.gz \
	--slave %{_mandir}/man8/sendmail.8.gz mta-sendmailman %{_mandir}/man8/sendmail.msmtpq-ng-mta.8.gz \
	--slave %{_mandir}/man5/aliases.5.gz mta-aliasesman %{_mandir}/man5/aliases.msmtpq-ng-mta.5.gz
%systemd_post ms-mta-queue-runner.timer

exit 0

%post ms-mta-smtpd-systemd
%systemd_post ms-mta-smtpd.socket

%post ms-mta-smtpd-xinetd
%systemd_post ms-mta-smtpd.socket

exit 0

%pre ms-mta-smtpd-systemd
# Add user and groups if necessary
%{_sbindir}/groupadd -g %{msmtp_scripts_gid} -r %{msmtp_scripts_group} 2>/dev/null
%{_sbindir}/useradd -d %{msmtp_scripts_queue_dir} -s /sbin/nologin -g %{msmtp_scripts_group} -M -r -u %{msmtp_scripts_uid} %{msmtp_scripts_user} 2>/dev/null
%systemd_post ms-mta-systemd.socket

%pre ms-mta-smtpd-xinetd
# Add user and groups if necessary
%{_sbindir}/groupadd -g %{msmtp_scripts_gid} -r %{msmtp_scripts_group} 2>/dev/null
%{_sbindir}/useradd -d %{msmtp_scripts_queue_dir} -s /sbin/nologin -g %{msmtp_scripts_group} -M -r -u %{msmtp_scripts_uid} %{msmtp_scripts_user} 2>/dev/null

%preun ms-mta-smtpd-systemd
%systemd_preun ms-mta-systemd.socket

%preun ms-mta-smtpd-xinetd
%systemd_preun xinetd.service

%preun msmtpq-ng-mta
if [ "$1" = 0 ]; then
    %{_sbindir}/alternatives --remove mta %{msmtp_scripts_admcmd_dir}/sendmail.msmtpq-ng-mta
fi
%systemd_preun ms-mta-queue-runner.timer

%postun ms-mta-smtpd-xinetd
%systemd_postun_with_restart xinetd.service

%post logwatch-selinux
if [ "$1" -le "1" ] ; then # First install
	semodule -i %{_datadir}/selinux/packages/%{name}/msmtp_scripts_logwatch.pp 2>/dev/null || :
fi

%preun logwatch-selinux
if [ "$1" -lt "1" ] ; then # Final removal
	semodule -i %{_datadir}/selinux/packages/%{name}/msmtp_scripts_logwatch.pp 2>/dev/null || :
fi

%postun logwatch-selinux
if [ "$1" -ge "1" ] ; then # Upgrade
	semodule -i %{_datadir}/selinux/packages/%{name}/msmtp_scripts_logwatch.pp 2>/dev/null || :
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files msmtpq-ng

%defattr(-, root, root, -)

%attr(0644, root, root) %config(noreplace) %{_sysconfdir}/msmtpq-ng.rc

# Documentation

%{msmtp_scripts_doc_dir}

%attr(0644, root, root) %{_mandir}/man1/msmtpq-ng.1*
%attr(0644, root, root) %{_mandir}/man1/msmtpq-ng-queue.1*
%attr(0755, root, root) %{msmtp_scripts_command_dir}/msmtpq-ng
%attr(0755, root, root) %{msmtp_scripts_command_dir}/msmtpq-ng-queue


%files msmtpq-ng-mta

%defattr(-, root, root, -)

# Documentation

%{msmtp_scripts_doc_dir}

# Misc files

%dir %attr(1777, root, root) %{msmtp_scripts_queue_dir}
%dir %attr(1777, root, root) %{msmtp_scripts_lock_dir}
%attr(0644, root, root) %{_tmpfilesdir}/msmtpq-ng-mta.conf

%{_mandir}/man1/msmtpq-ng-mta.1*
%{_mandir}/man1/msmtpq-ng-queue-mta.1*
%{_mandir}/man1/*.msmtpq-ng-mta.1*
%{_mandir}/man5/*.msmtpq-ng-mta.5*
%{_mandir}/man8/*.msmtpq-ng-mta.8*

%attr(0755, root, root) %{msmtp_scripts_admcmd_dir}/msmtpq-ng-mta
%attr(0755, root, root) %{msmtp_scripts_admcmd_dir}/msmtpq-ng-queue-mta

%{_bindir}/mailq.msmtpq-ng-mta
%{_bindir}/newaliases.msmtpq-ng-mta
%{_sbindir}/sendmail.msmtpq-ng-mta
/usr/lib/sendmail.msmtpq-ng-mta

%attr(0644, root, root) %config(noreplace) %{_sysconfdir}/msmtpq-ng-mta.rc
%attr(0644, root, root) %{_unitdir}/ms-mta-queue-run.timer
%attr(0644, root, root) %{_unitdir}/ms-mta-queue-run.service

%{_mandir}/man1/postqueue.1.gz
%{_mandir}/man1/postsuper.1.gz

%ghost %{_mandir}/man1/mailq.1.gz
%ghost %{_mandir}/man1/newaliases.1.gz
%ghost %{_mandir}/man5/aliases.5.gz
%ghost %{_mandir}/man8/sendmail.8.gz

%{_sbindir}/postqueue
%{_sbindir}/postsuper

%ghost %attr(0755, root, root) %{_bindir}/mailq
%ghost %attr(0755, root, root) %{_bindir}/newaliases
%ghost %attr(0755, root, root) %{_sbindir}/sendmail
%ghost %attr(0755, root, root) /usr/lib/sendmail

%files ms-mta-smtpd-systemd
%defattr(-, root, root, -)

%attr(0644, root, root) %{_unitdir}/ms-mta-smtpd@.service
%attr(0644, root, root) %{_unitdir}/ms-mta-smtpd.socket

%files ms-mta-smtpd-xinetd
%defattr(-, root, root, -)

%attr(0644, root, root) %config(noreplace) %{_sysconfdir}/xinetd.d/ms-mta-smtpd

%files logwatch-selinux
%defattr(-, root, root, -)

%attr(0644, root, root) %{_datadir}/selinux/packages/%{name}/msmtp_scripts_logwatch.pp

%changelog
* Fri Sep 6 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.5.1-2
  * The queue runner needs to run as root.  This needs to be set
    explicitly in the unit file.
  * Fix systemd and tmpfiles handling in the .spec

* Tue Sep 3 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.5.1-1
  * Actually add the permissions this time.
  * Switch to per-message locks
  * Various fixes

* Mon Sep 2 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.5-2
  * logwatch requires a few more pemssions in order to queue mail,
    do add them to the SELinux module.

* Thu Aug 29 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.5-1
  * New upstream
    - Instead of giving capabilities to confined processes, limit the
      new capabilities to those required to spool mail, and let the
      queue runner (which typically runs as root cron) take care of
      doing the actual sending.
    - Introduces a new setting MSMTP_QUEUE_FIRST which is a boolean
      which indicates that msmtpq-ng should not attempt to send mail
      when mail is initially 'sent' via msmtpq-ng (or via sendmail
      in the case msmtpq-ng-mta as system MTA) but instead just queue
      it and send when an explicit queue run is done.

* Mon Aug 26 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.4-5
  * Add more additional permissions required for smooth operation of
    msmtp-scripts + logwatch + selinux.

* Thu Aug 8 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.4-4
  * Add additional permissions required for smooth operation of msmtp-
    scripts + logwatch + selinux.

* Thu Aug 8 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.4-3
  * Fix for Fedora 30 + Rawhide change in package name for policycoreutils
    python utils.

* Wed Aug 7 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.4-2
  * Fix for logwatch with msmtpq-ng-mta with enforcing SELinux

* Mon Aug 5 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.4-1
  * New stable release

* Mon Aug 5 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.3-7
  * Use same name for source files as in packages
  * Fix systemd ms-mta-smtpd service so stdin and stdout are attached to
    socket.
  * Do volatile dir creation for lock dir (for systems were /var/lock is
    symlinked to non-persistent /run/lock).
  * Fix testing of el package build (logic fix).

* Mon Aug 5 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.3-6
- Fix extraneous CLI parameter to msmtp (was accidentally
  left in place after fixes for "msmtprc file has to be
  owned buy user."

* Mon Aug 5 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.3-5
- Fix so msmtpq-ng-mta is preferred to msmtp on Fedora

* Sun Aug 4 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.3-4
- Fix missing requires on msmtp
- Fix for mtmtprc file has to be own by user sending mail except system-wide
  /etc/msmtprc
- Fix various tests and documentation 

* Tue Jul 30 2019 Daniel F. Dickinson <cshored@thecshore.com> - 1.2.3-1
- Initial RPM
