#!/bin/sh
#
# msmtp-scripts test framework
#
#    Copyright (C) 2019 Daniel F. Dickinson <cshored@thecshore.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

OTS=SUCCESS

export MSMTP_SKIP_CONF=true
export MSMTP_OVERRIDE_CONF=./tmp/msmtpq-ng.rc

TS=PASS

rm -rf ./tmp/msmtp.queue/*
rm -f ./tmp/msmtp.queue.log

if  MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_THROUGH}15-1 /usr/bin/msmtpq-ng --help >./tmp/msmtpq-ng.help; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Show help for msmtpq-ng"

TS=PASS

if ! test -s ./tmp/msmtpq-ng.help; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Help for msmtpq-ng is not empty"

rm -f ./tmp/msmtpq-ng.help

TS=PASS

if MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_THROUGH}15-2 /usr/bin/msmtpq-ng-queue --help >./tmp/msmtpq-ng-queue.help; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Show help for msmtpq-ng-queue"

TS=PASS

if ! test -s ./tmp/msmtpq-ng-queue.help; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Help for msmtpq-ng-queue is not empty"

rm -f ./tmp/msmtpq-ng-queue.help

if [ "$OTS" = "FAIL" ]; then
	exit 3
else
	exit 0
fi
