#!/bin/sh
#
# msmtp-scripts test framework
#
#    Copyright (C) 2019 Daniel F. Dickinson <cshored@thecshore.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

OTS=SUCCESS

rm -rf ./tmp/msmtp.queue/*
rm -rf ./tmp/msmtp.lock/*
rm -f ./tmp/msmtp.queue.log
rm -f /tmp/msmtp-error-code

export MSMTP_SKIP_CONF=true
export MSMTP_OVERRIDE_CONF=./tmp/msmtpq-fail-code.rc
export OLDPATH="${PATH}"
PATH="$(pwd)/tests/scripts:${OLDPATH}"
export PATH

for code in $(seq 64 78); do
	TS=PASS

echo 'Subject: test error code "'"$code"'"

Test error code "'"$code"'"' | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}4-1 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}4-2" root
	MCTRC=$?

	if [ "$MCTRC" != "$code" ]; then
		echo "Got $MCTRC, expected $code"
		TS=FAIL
		OTS=FAIL
	fi

	echo "$TS: msmtp returns code $MCTRC when msmtp fails with $code"
done

rm -rf ./tmp/msmtp.queue/*
rm -rf ./tmp/msmtp.lock/*
rm -f ./tmp/msmtp.queue.log
rm -f /tmp/msmtp-error-code

if [ "$OTS" = "FAIL" ]; then
	exit 3
else
	exit 0
fi
