#!/bin/sh
#
# msmtp-scripts test framework
#
#    Copyright (C) 2019 Daniel F. Dickinson <cshored@thecshore.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

OTS=SUCCESS

TS=PASS

CURDIR="$(pwd)"
export MSMTP_SKIP_CONF=true
export MSMTP_OVERRIDE_CONF=./tmp/msmtpq-ng.rc

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}1 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}1"

MQRC=$?

if [ "$MQRC" != "67" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Sending without an addressee fails"

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}2 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}2" -- -F msmtp@example.com

MQRC=$?

if [ "$MQRC" != "64" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Sending with non-recipient parameters after ' -- ' fails"

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}3 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}3" -- msmtp@example.com george@example.com

MQRC=$?

if [ "$MQRC" != "0" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Sending with only recipient parameters after ' -- ' succeeds"

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}4 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}4" -f msmtp@example.com -- george@example.com

MQRC=$?

if [ "$MQRC" != "0" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Sending with only from (-f) properly set succeeds"

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}4 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}4" -f -f msmtp@example.com -- george@example.com

MQRC=$?

if [ "$MQRC" != "64" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Having -f where there should be an address fails"

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}4 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}4" -f -m msmtp@example.com -- george@example.com

MQRC=$?

if [ "$MQRC" != "64" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Having -m where there should be an address fails"

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}4 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}4" -f -L msmtp@example.com -- george@example.com

MQRC=$?

if [ "$MQRC" != "64" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Having -L where there should be an address fails"

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}4 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}4" -t

MQRC=$?

if [ "$MQRC" != "0" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Using -t properly succeeds."

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}5 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}5" -f -t

MQRC=$?

if [ "$MQRC" != "64" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Sending with from (-f) not followed by an address fails"

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}6 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}5" -bm root

MQRC=$?

if [ "$MQRC" != "0" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Sending with a compatibility parameter succeeds but ignores the parameter"

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}7 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}6" -L blah root

MQRC=$?

if [ "$MQRC" != "0" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Sending with an compatibility parameter requiring value and addressee succeeds"

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}8 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}7" -x blah root

MQRC=$?

if [ "$MQRC" != "64" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Sending with an unknown parameter fails"


export MSMTP_OVERRIDE_CONF=./tmp/msmtpq-ng-real.rc

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}9 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}8" -f msmtp@example.com -bm

MQRC=$?

if [ "$MQRC" != "67" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Sending with a from but no recipient fails"

TS=PASS

echo "Subject: Add a non-held message

Test a non-held message cli parameters." | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}10 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}9" -L root

MQRC=$?

if [ "$MQRC" != "67" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Sending with an compatibility parameter requiring value, but no addressee, fails"

if [ "$OTS" = "FAIL" ]; then
	exit 3
else
	exit 0
fi
