#!/bin/sh
#
# msmtp-scripts test framework
#
#    Copyright (C) 2019 Daniel F. Dickinson <cshored@thecshore.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#!/bin/sh
#

OTS=SUCCESS

rm -rf ./tmp/msmtp.queue/*
rm -f ./tmp/msmtp.queue.log

export MSMTP_SKIP_CONF=true
export MSMTP_OVERRIDE_CONF=./tmp/msmtpq-fail.rc
echo "Subject: Test mail queueing

Test mail queueing" | MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}10-1 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}10-1" root || true

TS=PASS

rm -f ./tmp/msmtpq-ng-queue.out

if ! /usr/bin/msmtpq-ng -bp >./tmp/msmtpq-ng-queue.out; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: List queue"

TS=PASS

if [ ! -s ./tmp/msmtpq-ng-queue.out ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Queue list non-empty"

if [ "$OTS" = "FAIL" ]; then
	exit 3
else
	exit 0
fi
