#!/bin/sh
#
# msmtp-scripts test framework
#
#    Copyright (C) 2019 Daniel F. Dickinson <cshored@thecshore.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

OTS=SUCCESS

export MSMTP_SKIP_CONF=true
export MSMTP_OVERRIDE_CONF=./tmp/msmtpq-fail.rc

echo "Subject: Test mail queueing

Test mail queueing" | /usr/bin/msmtpq-ng root 

TS=PASS

export MSMTP_SKIP_CONF=true
export MSMTP_OVERRIDE_CONF=./tmp/msmtpq-ng.rc

if !  MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}11-1 /usr/bin/msmtpq-ng-queue -kcov "${KCOV_BASE}11-1" -h ALL; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Hold all messages"

TS=PASS

if [ -z "$(ls -A ./tmp/msmtp.queue/*.hold 2>/dev/null)" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Message(s) held"

TS=PASS

if ! MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}11-2 /usr/bin/msmtpq-ng-queue -kcov "${KCOV_BASE}11-2" -H ALL; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Unhold all messages"

TS=PASS

if [ -n "$(ls -A ./tmp/msmtp.queue/*.hold 2>/dev/null)" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: No message(s) held"

TS=PASS

if ! MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}11-3 /usr/bin/msmtpq-ng-queue -kcov "${KCOV_BASE}11-3" -d ALL; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Purge all messages"

TS=PASS

if [ -n "$(ls -A ./tmp/msmtp.queue/* 2>/dev/null)" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: All messages purged"

if [ "$OTS" = "FAIL" ]; then
	exit 3
else
	exit 0
fi
