#!/bin/sh
#
# msmtp-scripts test framework
#
#    Copyright (C) 2019 Daniel F. Dickinson <cshored@thecshore.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

OTS=SUCCESS

if [ -r /etc/os-release ]; then
	. /etc/os-release

	if  command -v dpkg-buildpackage >/dev/null; then

		dpkg-buildpackage -b -uc -us >./tmp/dpkg-build.log || OTS=FAIL

		if [ "$OTS" = "SUCCESS" ]; then
			echo "PASS: Debian package build succeeded"
		else
			echo "FAIL: Debian package build failed"
		fi

	else
		echo "SKIP: Skipping debian package build on non-debian host"
	fi
else
	OTS=FAIL
	echo "FAIL: Unable to determine OS type"
fi

if [ "$OTS" = "FAIL" ]; then
	exit 3
else
	exit 0
fi
