#!/bin/sh
#
# msmtp-scripts test framework
#
#    Copyright (C) 2019 Daniel F. Dickinson <cshored@thecshore.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

OTS=SUCCESS

export MSMTP_SKIP_CONF=true
export MSMTP_OVERRIDE_CONF=./tmp/msmtpq-ng-lock-fail.rc

rm -rf ./tmp/msmtp.queue/*
rm -rf ./tmp/msmtp.lock/*
rm -f ./tmp/msmtp.queue.log

TS=PASS

echo "Subject: lock failure testing
       
Lock failure test"| MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}12-1 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}12-1" root
MQLFRC=$?

if [ "$MQLFRC" != "71" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Lock failure generates error for msmtpq-ng"

rm -rf ./tmp/msmtp.lock/*

export MSMTP_OVERRIDE_CONF=./tmp/msmtpq-fail.rc

echo "Subject: lock failure testing
       
Lock failure test"| MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}12-2 /usr/bin/msmtpq-ng -kcov "${KCOV_BASE}12-2" root

TS=PASS


export MSMTP_OVERRIDE_CONF=./tmp/msmtpq-ng.rc

/usr/bin/msmtpq-ng-queue |tail -n+3|head -n-1|head -n1|cut -f1 -d\*  >./tmp/qtestid

export MSMTP_OVERRIDE_CONF=./tmp/msmtpq-ng-lock-fail.rc

MSMTP_SKIP_CONF=true MSMTP_OVERRIDE_CONF=${MSMTP_OVERRIDE_CONF} ${KCOV_OUTSIDE}12-3 /usr/bin/msmtpq-ng-queue -kcov "${KCOV_BASE}12-3" -d "$(cat ./tmp/qtestid)"
MQLFRC=$?

if [ "$MQLFRC" != "71" ]; then
	TS=FAIL
	OTS=FAIL
fi

echo "$TS: Lock failure generates error for msmtpq-ng-queue"

if [ "$OTS" = "FAIL" ]; then
	exit 3
else
	exit 0
fi
